# -*- coding: utf-8 -*-
# Generated by Django 1.10.8 on 2017-10-02 23:44
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0008_alter_user_username_max_length'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('wagtailcore', '0040_page_draft_title'),
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='ApprovalPipeline',
            fields=[
                ('page_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='wagtailcore.Page')),
                ('notes', models.TextField(blank=True)),
                ('user', models.ForeignKey(blank=True, default=None, help_text='This is the user that is set to be the owner of all pages that become owned by this pipeline.', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL, verbose_name='owned user')),
            ],
            options={
                'verbose_name': 'approval pipeline',
                'verbose_name_plural': 'approval pipelines',
            },
            bases=('wagtailcore.page',),
        ),
        migrations.CreateModel(
            name='ApprovalStep',
            fields=[
                ('page_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='wagtailcore.Page')),
                ('can_delete', models.BooleanField(default=False, help_text='Whether or not owned objects can be deleted', verbose_name='can delete owned objects')),
                ('can_edit', models.BooleanField(default=False, help_text='Whether or not owned objects can be edited.  This may be False for most non-edit steps, such as Approval, Published, or automatic Approval steps', verbose_name='can edit owned objects')),
                ('private_to_group', models.BooleanField(default=True, help_text='Whether the object is made private to its group.  This is done for most steps, and should typically only be disabled for a published step.', verbose_name='make owned objects private to group')),
                ('approval_step', models.ForeignKey(blank=True, default=None, help_text='The step that ownership is given to on approval', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='wagtailapproval.ApprovalStep', verbose_name='approval step')),
                ('collection', models.ForeignKey(blank=True, default=None, help_text='The collection that collection member objects are assigned to.  This step is the strict owner of this collection', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='wagtailcore.Collection', verbose_name='owned collection')),
                ('group', models.ForeignKey(blank=True, default=None, help_text='The group that permissions are modified for on entering or leaving this step. This should apply for pages as well as collections.  For all intents and purposes, users in this group are owned by this step, and everything they do is subject to the approval pipeline.  This step is the strict owner of this group.', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='auth.Group', verbose_name='owned group')),
                ('rejection_step', models.ForeignKey(blank=True, default=None, help_text='The step that ownership is given to on rejection', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='wagtailapproval.ApprovalStep', verbose_name='rejection step')),
            ],
            options={
                'abstract': False,
            },
            bases=('wagtailcore.page',),
        ),
        migrations.CreateModel(
            name='ApprovalTicket',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('object_id', models.PositiveIntegerField()),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
                ('step', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='wagtailapproval.ApprovalStep')),
            ],
        ),
        migrations.AlterUniqueTogether(
            name='approvalticket',
            unique_together=set([('step', 'content_type', 'object_id')]),
        ),
    ]
